
#define DECNUMDIGITS 70                         ' work with up to 70 digits

#include once "decNumber/decContext.bi"
#include once "decNumber/decNumber.bi"
'#include once "decNumber/decQuad.bi"

dim as decNumber zero, one, mtwo, three, hundred, one_half       ' constants
dim as decNumber start, rate, years, x ,y      ' parameters
dim as decNumber total                    ' result
dim as double t1, t2

Function invSqr (Byref x As decNumber) As decNumber
    Dim As integer i=16
    Dim As decNumber xk
    Dim As decNumber one_half = 0.5
    if x<0 then
        print "Argument to Sqr is negative."
        stop
    end if
    if x=0 then
        xk=0
    else
        xk = 1/sqr(x)
        while i<DECNUMDIGITS
            xk = xk+xk*one_half*(1-x*xk*xk)
            i=i+i
        wend
    endif
    Return xk
End Function

function pi() as decNumber
    Dim as decNumber a,a1,b,b1,d,d1,p1,p2,tp,t
    Dim as integer i=0
    Dim As decNumber one_half = 0.5
    t="1e-"+str(DECNUMDIGITS-4)
    a=1
    tp=2
    b=invSqr(tp)
    d=Sqr(tp)-one_half
    p1=a+b
    p1=p1*p1/d
    p2=3
    while dec_abs(a-b)>t
        p1=p2
        a1=(a+b)*one_half
        b1=sqr(a*b)
        d1=(a1-b1)
        d=d-tp*d1*d1
        a=a1
        b=b1
        tp=tp*2
        p2=a+b
        p2=p2*p2/d
    wend
    return p2
end function
dim as double d=2
dim as integer n=3
    Dim As decContext set
    Dim as uinteger status
    dim as uinteger nn
    decContextDefault (@set, DEC_INIT_BASE)
    set.digits = DECNUMDIGITS
    set.emax = DEC_MAX_MATH
    set.emin = -DEC_MAX_MATH
x="2"
y="0"

? "log(2)
y=log(x) 'decNumberLn (@y, @x, @set)
'decNumberExp (@y, @y, @set)
? y
?
? "log(2)^2"
y=y^2 'decNumberPower(@y, @y, @x, @set)
print y
?
t1=timer
x=pi()
? "Pi"
? x
?
t2=timer
print "it took ";t2-t1;" seconds to calculate Pi to ";DECNUMDIGITS;" digits"
?
? "decCheckMath on x = ";decCheckMath(@x, @set, @status)
?
? "status = ";status
?
? "DEC_ROUND_CEILING = ";DEC_ROUND_CEILING
?
Print "press return key to end";
sleep
