''
''
'' decDouble -- header translated with help of SWIG FB wrapper
''
'' NOTICE: This file is part of the FreeBASIC Compiler package and can't
''         be included in other distributions without authorization.
''
''
#ifndef __decDouble_bi__
#define __decDouble_bi__

#define DECDOUBLENAME "decimalDouble"
#define DECDOUBLETITLE "Decimal 64-bit datum"
#define DECDOUBLEAUTHOR "Mike Cowlishaw"
#define DECDOUBLE_Bytes 8
#define DECDOUBLE_Pmax 16
#define DECDOUBLE_Emin -383
#define DECDOUBLE_Emax 384
#define DECDOUBLE_EmaxD 3
#define DECDOUBLE_Bias 398
#define DECDOUBLE_String 25
#define DECDOUBLE_EconL 8
#define DECDOUBLE_Declets 5
#define DECDOUBLE_Ehigh (384+398-(16-1))

union decDouble
	bytes(0 to DECDOUBLE_Bytes-1) as uint8_t
	shorts(0 to DECDOUBLE_Bytes/2-1) as uint16_t
	words(0 to DECDOUBLE_Bytes/4-1) as uint32_t
end union

declare function decDoubleFromBCD cdecl alias "decDoubleFromBCD" (byval as decDouble ptr, byval as int32_t, byval as uint8_t ptr, byval as int32_t) as decDouble ptr
declare function decDoubleFromInt32 cdecl alias "decDoubleFromInt32" (byval as decDouble ptr, byval as int32_t) as decDouble ptr
declare function decDoubleFromPacked cdecl alias "decDoubleFromPacked" (byval as decDouble ptr, byval as int32_t, byval as uint8_t ptr) as decDouble ptr
declare function decDoubleFromPackedChecked cdecl alias "decDoubleFromPackedChecked" (byval as decDouble ptr, byval as int32_t, byval as uint8_t ptr) as decDouble ptr
declare function decDoubleFromString cdecl alias "decDoubleFromString" (byval as decDouble ptr, byval as zstring ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleFromUInt32 cdecl alias "decDoubleFromUInt32" (byval as decDouble ptr, byval as uint32_t) as decDouble ptr
declare function decDoubleFromWider cdecl alias "decDoubleFromWider" (byval as decDouble ptr, byval as decQuad ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleGetCoefficient cdecl alias "decDoubleGetCoefficient" (byval as decDouble ptr, byval as uint8_t ptr) as int32_t
declare function decDoubleGetExponent cdecl alias "decDoubleGetExponent" (byval as decDouble ptr) as int32_t
declare function decDoubleSetCoefficient cdecl alias "decDoubleSetCoefficient" (byval as decDouble ptr, byval as uint8_t ptr, byval as int32_t) as decDouble ptr
declare function decDoubleSetExponent cdecl alias "decDoubleSetExponent" (byval as decDouble ptr, byval as decContext ptr, byval as int32_t) as decDouble ptr
declare sub decDoubleShow cdecl alias "decDoubleShow" (byval as decDouble ptr, byval as zstring ptr)
declare function decDoubleToBCD cdecl alias "decDoubleToBCD" (byval as decDouble ptr, byval as int32_t ptr, byval as uint8_t ptr) as int32_t
declare function decDoubleToEngString cdecl alias "decDoubleToEngString" (byval as decDouble ptr, byval as zstring ptr) as zstring ptr
declare function decDoubleToInt32 cdecl alias "decDoubleToInt32" (byval as decDouble ptr, byval as decContext ptr, byval as rounding) as int32_t
declare function decDoubleToInt32Exact cdecl alias "decDoubleToInt32Exact" (byval as decDouble ptr, byval as decContext ptr, byval as rounding) as int32_t
declare function decDoubleToPacked cdecl alias "decDoubleToPacked" (byval as decDouble ptr, byval as int32_t ptr, byval as uint8_t ptr) as int32_t
declare function decDoubleToString cdecl alias "decDoubleToString" (byval as decDouble ptr, byval as zstring ptr) as zstring ptr
declare function decDoubleToUInt32 cdecl alias "decDoubleToUInt32" (byval as decDouble ptr, byval as decContext ptr, byval as rounding) as uint32_t
declare function decDoubleToUInt32Exact cdecl alias "decDoubleToUInt32Exact" (byval as decDouble ptr, byval as decContext ptr, byval as rounding) as uint32_t
declare function decDoubleToWider cdecl alias "decDoubleToWider" (byval as decDouble ptr, byval as decQuad ptr) as decQuad ptr
declare function decDoubleZero cdecl alias "decDoubleZero" (byval as decDouble ptr) as decDouble ptr
declare function decDoubleAbs cdecl alias "decDoubleAbs" (byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleAdd cdecl alias "decDoubleAdd" (byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleAnd cdecl alias "decDoubleAnd" (byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleDivide cdecl alias "decDoubleDivide" (byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleDivideInteger cdecl alias "decDoubleDivideInteger" (byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleFMA cdecl alias "decDoubleFMA" (byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleInvert cdecl alias "decDoubleInvert" (byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleLogB cdecl alias "decDoubleLogB" (byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleMax cdecl alias "decDoubleMax" (byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleMaxMag cdecl alias "decDoubleMaxMag" (byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleMin cdecl alias "decDoubleMin" (byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleMinMag cdecl alias "decDoubleMinMag" (byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleMinus cdecl alias "decDoubleMinus" (byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleMultiply cdecl alias "decDoubleMultiply" (byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleNextMinus cdecl alias "decDoubleNextMinus" (byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleNextPlus cdecl alias "decDoubleNextPlus" (byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleNextToward cdecl alias "decDoubleNextToward" (byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleOr cdecl alias "decDoubleOr" (byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoublePlus cdecl alias "decDoublePlus" (byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleQuantize cdecl alias "decDoubleQuantize" (byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleReduce cdecl alias "decDoubleReduce" (byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleRemainder cdecl alias "decDoubleRemainder" (byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleRemainderNear cdecl alias "decDoubleRemainderNear" (byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleRotate cdecl alias "decDoubleRotate" (byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleScaleB cdecl alias "decDoubleScaleB" (byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleShift cdecl alias "decDoubleShift" (byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleSubtract cdecl alias "decDoubleSubtract" (byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleToIntegralValue cdecl alias "decDoubleToIntegralValue" (byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr, byval as rounding) as decDouble ptr
declare function decDoubleToIntegralExact cdecl alias "decDoubleToIntegralExact" (byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleXor cdecl alias "decDoubleXor" (byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleCompare cdecl alias "decDoubleCompare" (byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleCompareSignal cdecl alias "decDoubleCompareSignal" (byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr, byval as decContext ptr) as decDouble ptr
declare function decDoubleCompareTotal cdecl alias "decDoubleCompareTotal" (byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr) as decDouble ptr
declare function decDoubleCompareTotalMag cdecl alias "decDoubleCompareTotalMag" (byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr) as decDouble ptr
declare function decDoubleCanonical cdecl alias "decDoubleCanonical" (byval as decDouble ptr, byval as decDouble ptr) as decDouble ptr
declare function decDoubleCopy cdecl alias "decDoubleCopy" (byval as decDouble ptr, byval as decDouble ptr) as decDouble ptr
declare function decDoubleCopyAbs cdecl alias "decDoubleCopyAbs" (byval as decDouble ptr, byval as decDouble ptr) as decDouble ptr
declare function decDoubleCopyNegate cdecl alias "decDoubleCopyNegate" (byval as decDouble ptr, byval as decDouble ptr) as decDouble ptr
declare function decDoubleCopySign cdecl alias "decDoubleCopySign" (byval as decDouble ptr, byval as decDouble ptr, byval as decDouble ptr) as decDouble ptr
declare function decDoubleClass cdecl alias "decDoubleClass" (byval as decDouble ptr) as decClass
declare function decDoubleClassString cdecl alias "decDoubleClassString" (byval as decDouble ptr) as zstring ptr
declare function decDoubleDigits cdecl alias "decDoubleDigits" (byval as decDouble ptr) as uint32_t
declare function decDoubleIsCanonical cdecl alias "decDoubleIsCanonical" (byval as decDouble ptr) as uint32_t
declare function decDoubleIsFinite cdecl alias "decDoubleIsFinite" (byval as decDouble ptr) as uint32_t
declare function decDoubleIsInfinite cdecl alias "decDoubleIsInfinite" (byval as decDouble ptr) as uint32_t
declare function decDoubleIsInteger cdecl alias "decDoubleIsInteger" (byval as decDouble ptr) as uint32_t
declare function decDoubleIsNaN cdecl alias "decDoubleIsNaN" (byval as decDouble ptr) as uint32_t
declare function decDoubleIsNormal cdecl alias "decDoubleIsNormal" (byval as decDouble ptr) as uint32_t
declare function decDoubleIsSignaling cdecl alias "decDoubleIsSignaling" (byval as decDouble ptr) as uint32_t
declare function decDoubleIsSignalling cdecl alias "decDoubleIsSignalling" (byval as decDouble ptr) as uint32_t
declare function decDoubleIsSigned cdecl alias "decDoubleIsSigned" (byval as decDouble ptr) as uint32_t
declare function decDoubleIsSubnormal cdecl alias "decDoubleIsSubnormal" (byval as decDouble ptr) as uint32_t
declare function decDoubleIsZero cdecl alias "decDoubleIsZero" (byval as decDouble ptr) as uint32_t
declare function decDoubleRadix cdecl alias "decDoubleRadix" (byval as decDouble ptr) as uint32_t
declare function decDoubleSameQuantum cdecl alias "decDoubleSameQuantum" (byval as decDouble ptr, byval as decDouble ptr) as uint32_t
declare function decDoubleVersion cdecl alias "decDoubleVersion" () as zstring ptr

#endif
